<?php
/**
 * Clase Base FN para BaseCrPlanillaPeriodoFN
 *
 * @package    
 * @subpackage BaseCrPlanillaPeriodoFN
 * @author     Willy
 * @version    SVN:: BaseCrPlanillaPeriodoFN.class.php,v 1.1 2014-03-12 10:44:57 william.taype Exp $
 */
class BaseCrPlanillaPeriodoFN extends CrPlanillaPeriodoBN
{
  private static $fieldNames = array (
    'Periodo'=>'Periodo', 'Estado'=>'Estado', 'Activo'=>'Activo', 'TotalIngresos'=>'TotalIngresos', 'TotalDescuentos'=>'TotalDescuentos', 'Neto'=>'Neto', 'FechaCierre'=>'FechaCierre', 'FechaApertura'=>'FechaApertura'  
  );

  public function select()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT Periodo, Estado, Activo, TotalIngresos, TotalDescuentos, Neto, FechaCierre, FechaApertura FROM cr_planilla_periodo WHERE 1 ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
      //echo $sql;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT Periodo, Estado, Activo, TotalIngresos, TotalDescuentos, Neto, FechaCierre, FechaApertura FROM cr_planilla_periodo WHERE 1 ".$where;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getPeriodo()){ $where .= " AND periodo = '".$this->getPeriodo()."'"; }
      if($this->getEstado()){ $where .= " AND estado = '".$this->getEstado()."'"; }
      if($this->getActivo()){ $where .= " AND activo = '".$this->getActivo()."'"; }
      if($this->getTotalIngresos()){ $where .= " AND totalingresos = '".$this->getTotalIngresos()."'"; }
      if($this->getTotalDescuentos()){ $where .= " AND totaldescuentos = '".$this->getTotalDescuentos()."'"; }
      if($this->getNeto()){ $where .= " AND neto = '".$this->getNeto()."'"; }
      if($this->getFechaCierre()){ $where .= " AND fechacierre = '".$this->getFechaCierre()."'"; }
      if($this->getFechaApertura()){ $where .= " AND fechaapertura = '".$this->getFechaApertura()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* B�squeda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT Periodo, Estado, Activo, TotalIngresos, TotalDescuentos, Neto, FechaCierre, FechaApertura FROM cr_planilla_periodo WHERE 1 AND Periodo='".$this->getPeriodo()."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_BaseCrPlanillaPeriodoFN = new BaseCrPlanillaPeriodoFN();
    $o_BaseCrPlanillaPeriodoFN->setPeriodo($o_propel->Periodo);
    $o_BaseCrPlanillaPeriodoFN->setEstado($o_propel->Estado);
    $o_BaseCrPlanillaPeriodoFN->setActivo($o_propel->Activo);
    $o_BaseCrPlanillaPeriodoFN->setTotalIngresos($o_propel->TotalIngresos);
    $o_BaseCrPlanillaPeriodoFN->setTotalDescuentos($o_propel->TotalDescuentos);
    $o_BaseCrPlanillaPeriodoFN->setNeto($o_propel->Neto);
    $o_BaseCrPlanillaPeriodoFN->setFechaCierre($o_propel->FechaCierre);
    $o_BaseCrPlanillaPeriodoFN->setFechaApertura($o_propel->FechaApertura);
    return $o_BaseCrPlanillaPeriodoFN;
  }
}